import type { DocumentNode } from "graphql";
export type DocumentTransformCacheKey = ReadonlyArray<unknown>;
type TransformFn = (document: DocumentNode) => DocumentNode;
interface DocumentTransformOptions {
    cache?: boolean;
    getCacheKey?: (document: DocumentNode) => DocumentTransformCacheKey | undefined;
}
export declare class DocumentTransform {
    private readonly transform;
    private cached;
    private readonly resultCache;
    private getCacheKey;
    static identity(): DocumentTransform;
    static split(predicate: (document: DocumentNode) => boolean, left: DocumentTransform, right?: DocumentTransform): DocumentTransform;
    constructor(transform: TransformFn, options?: DocumentTransformOptions);
    /**
     * Resets the internal cache of this transform, if it has one.
     */
    resetCache(): void;
    private performWork;
    transformDocument(document: DocumentNode): DocumentNode;
    concat(otherTransform: DocumentTransform): DocumentTransform;
}
export {};
//# sourceMappingURL=DocumentTransform.d.ts.map